diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/build-support/pkgconfig-template.pc.in ns-3.36/build-support/pkgconfig-template.pc.in
--- ns-3.35/build-support/pkgconfig-template.pc.in	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/build-support/pkgconfig-template.pc.in	2022-04-30 18:23:57.642732600 -0700
@@ -0,0 +1,13 @@
+exec_prefix="@CMAKE_INSTALL_FULL_BINDIR@"
+libdir="@CMAKE_INSTALL_FULL_LIBDIR@"
+includedir="@CMAKE_INSTALL_FULL_INCLUDEDIR@"
+
+Name: ns3-@module_name@
+Description: @CMAKE_PROJECT_DESCRIPTION@
+URL: @CMAKE_PROJECT_HOMEPAGE_URL@
+Version: @ns3_version@
+Requires: @pkgconfig_public_required@
+Requires.private: @pkgconfig_private_required@
+Cflags: -I"${includedir}" @pkgconfig_interface_include_directories@
+Libs: -L"${libdir}" -l@pkgconfig_target_lib@ @pkgconfig_public_libs@
+Libs.private: -L"${libdir}" @pkgconfig_private_libs@
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/build-support/pybindings-LP64-to-ILP32.py ns-3.36/build-support/pybindings-LP64-to-ILP32.py
--- ns-3.35/build-support/pybindings-LP64-to-ILP32.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/build-support/pybindings-LP64-to-ILP32.py	2022-04-30 18:23:57.642732600 -0700
@@ -0,0 +1,16 @@
+#! /usr/bin/env python3
+# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
+
+def lp64_to_ilp32(lp64path, ilp32path):
+    import re
+    lp64bindings = None
+    with open(lp64path, "r") as lp64file:
+        lp64bindings = lp64file.read()
+    with open(ilp32path, "w") as ilp32file:
+        ilp32bindings = re.sub("unsigned long(?!( long))", "unsigned long long", lp64bindings)
+        ilp32file.write(ilp32bindings)
+
+if __name__ == "__main__":
+    import sys
+    print(sys.argv)
+    exit(lp64_to_ilp32(sys.argv[1], sys.argv[2]))
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/build-support/version.cache.in ns-3.36/build-support/version.cache.in
--- ns-3.35/build-support/version.cache.in	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/build-support/version.cache.in	2022-04-30 18:23:57.642732600 -0700
@@ -0,0 +1,10 @@
+CLOSEST_TAG = '"@NS3_VERSION_CLOSEST_TAG@"'
+VERSION_COMMIT_HASH = '"@NS3_VERSION_COMMIT_HASH@"'
+VERSION_DIRTY_FLAG = '@NS3_VERSION_DIRTY_FLAG@'
+VERSION_MAJOR = '@NS3_VERSION_MAJOR@'
+VERSION_MINOR = '@NS3_VERSION_MINOR@'
+VERSION_PATCH = '@NS3_VERSION_PATCH@'
+VERSION_RELEASE_CANDIDATE = '@NS3_VERSION_RELEASE_CANDIDATE@'
+VERSION_TAG = '"@NS3_VERSION_TAG@"'
+VERSION_TAG_DISTANCE = '@NS3_VERSION_TAG_DISTANCE@'
+VERSION_BUILD_PROFILE = '@NS3_VERSION_BUILD_PROFILE@'
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/build-support/version-defines-template.h ns-3.36/build-support/version-defines-template.h
--- ns-3.35/build-support/version-defines-template.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/build-support/version-defines-template.h	2022-04-30 18:23:57.642732600 -0700
@@ -0,0 +1,145 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Mathew Bielejeski <bielejeski1@llnl.gov>
+ */
+
+#ifndef NS3_VERSION_DEFINES_H_
+#define NS3_VERSION_DEFINES_H_
+
+/**
+  * \file
+  * \ingroup buildversion
+  * Defines the macro values for printing the build version.
+  * These will be populated by the build system.
+  */
+
+/**
+  * \ingroup buildversion
+  * @{
+  */
+
+/**
+ * The first tag found which matches the pattern ns-3*.
+ *
+ * The expected format of the ns-3 version tag is: ns-3.<minor>[.patch][-release_candidate]
+ *
+ * The tag is found by starting at the tip of the current branch and walking
+ * back towards the root.
+ *
+ * Type: string literal
+ */
+#cmakedefine NS3_VERSION_TAG "@NS3_VERSION_TAG@"
+
+/**
+ * The tag closest to the tip of the current branch
+ *
+ * The tag is found by starting at the tip of the current branch and
+ * walking back towards the root.
+ *
+ * This value will be the same as #NS3_VERSION_TAG when #NS3_VERSION_TAG is
+ * the closest tag.
+ *
+ * Type: string literal
+ */
+#cmakedefine NS3_VERSION_CLOSEST_TAG "@NS3_VERSION_CLOSEST_TAG@"
+
+/**
+ * The major version extracted from #NS3_VERSION_TAG
+ *
+ * For a tag with the format ns-<digit>.<digit>[.digit], the major
+ * version is the number after ns- and before the first period.
+ *
+ * Type: integer
+ */
+#cmakedefine NS3_VERSION_MAJOR @NS3_VERSION_MAJOR@
+
+/**
+ * The minor version extracted from #NS3_VERSION_TAG
+ *
+ * For a tag with the format ns-<digit>.<digit>[.digit], the minor
+ * version is the number after the first period.
+ *
+ * Type: integer
+ */
+#cmakedefine NS3_VERSION_MINOR @NS3_VERSION_MINOR@
+
+/**
+ * The patch number extracted from #NS3_VERSION_TAG
+ *
+ * For a tag with the format ns-<digit>.<digit>[.digit], the patch
+ * is the number after the last period.
+ *
+ * The patch value is optional and may not be present in the tag.
+ * In cases where the patch value is not present, the field will be set to 0
+ *
+ * Type: integer
+ */
+#cmakedefine NS3_VERSION_PATCH @NS3_VERSION_PATCH@
+
+/**
+ * The portion of the #NS3_VERSION_TAG indicating the version
+ * of the release candidate (if applicable).
+ *
+ * In order for this field to contain a value, the #NS3_VERSION_TAG
+ * must have the format ns-<digit>.<digit>[.digit][-RC<digit>].
+ * The contents of the release candidate will be the RC<digit>
+ * portion of the tag.
+ *
+ * Type: string literal
+ */
+#cmakedefine NS3_VERSION_RELEASE_CANDIDATE @NS3_VERSION_RELEASE_CANDIDATE@
+
+/**
+ * The number of repository commits between #NS3_VERSION_CLOSEST_TAG
+ * and the branch HEAD.
+ *
+ * Type: integer
+ */
+#cmakedefine NS3_VERSION_TAG_DISTANCE @NS3_VERSION_TAG_DISTANCE@
+
+/**
+ * Hash value which uniquely identifies the commit of the
+ * branch HEAD.
+ * The first character of the commit hash is 'g' to indicate this hash is
+ * a git hash
+ *
+ * Type: string literal
+ */
+#cmakedefine NS3_VERSION_COMMIT_HASH "@NS3_VERSION_COMMIT_HASH@"
+
+/**
+ * Flag indicating whether the repository working tree had uncommitted
+ * changes when the library was built.
+ *
+ * The flag will be 1 if there were uncommitted changes, 0 otherwise.
+ *
+ * Type: integer
+ */
+#cmakedefine01 NS3_VERSION_DIRTY_FLAG
+
+/**
+ * Indicates the build profile that was specified by the --build-profile option
+ * of "ns3 configure"
+ *
+ * Type: string literal
+ */
+#cmakedefine NS3_VERSION_BUILD_PROFILE "@NS3_VERSION_BUILD_PROFILE@"
+
+/** @} */
+
+#endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/CMakeLists.txt ns-3.36/CMakeLists.txt
--- ns-3.35/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/CMakeLists.txt	2022-04-30 18:23:57.638732400 -0700
@@ -0,0 +1,147 @@
+# ##############################################################################
+# Required CMake version            #
+# ##############################################################################
+cmake_minimum_required(VERSION 3.10..3.10)
+
+# Use ccache if available
+mark_as_advanced(CCACHE_FOUND)
+find_program(CCACHE ccache)
+if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
+  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
+  message(
+    STATUS "CCache is enabled. Precompiled headers are disabled by default."
+  )
+  set(NS3_PRECOMPILE_HEADERS OFF
+      CACHE BOOL "Precompile module headers to speed up compilation" FORCE
+  )
+endif()
+
+# ##############################################################################
+# Project name                        #
+# ##############################################################################
+project(NS3 CXX)
+
+file(STRINGS VERSION NS3_VER)
+
+# minimum compiler versions
+set(AppleClang_MinVersion 11.0.0)
+set(Clang_MinVersion 6.0.0)
+set(GNU_MinVersion 8.0.0)
+
+# common options
+option(NS3_ASSERT "Enable assert on failure" OFF)
+option(NS3_DES_METRICS "Enable DES Metrics event collection" OFF)
+option(NS3_EXAMPLES "Enable examples to be built" OFF)
+option(NS3_LOG "Enable logging to be built" OFF)
+option(NS3_TESTS "Enable tests to be built" OFF)
+
+# fd-net-device options
+option(NS3_EMU "Build with emulation support" ON)
+option(NS3_TAP "Build with Tap support" ON)
+
+# maintenance and documentation
+option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
+option(NS3_CLANG_TIDY "Use clang-tidy static analysis" OFF)
+option(NS3_CLANG_TIMETRACE
+       "Collect compilation statistics to analyze the build process" OFF
+)
+option(NS3_COLORED_OUTPUT "Colorize CMake messages" OFF)
+option(NS3_COVERAGE "Enable code coverage measurements and report generation"
+       OFF
+)
+option(NS3_COVERAGE_ZERO_COUNTERS
+       "Zero lcov counters before running. Requires NS3_COVERAGE=ON" OFF
+)
+option(NS3_INCLUDE_WHAT_YOU_USE
+       "Use IWYU to determine unnecessary headers included" OFF
+)
+option(NS3_LINK_WHAT_YOU_USE
+       "Use LWYU to determine unnecessary linked libraries" OFF
+)
+option(NS3_SANITIZE "Build with address, leak and undefined sanitizers" OFF)
+option(NS3_SANITIZE_MEMORY "Build with memory sanitizer" OFF)
+option(NS3_SCAN_PYTHON_BINDINGS "Scan python bindings" OFF)
+
+# 3rd-party libraries/programs
+option(NS3_NETANIM "Build netanim" OFF)
+
+# other options
+option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
+option(NS3_GNUPLOT "Build with Gnuplot support" OFF)
+option(NS3_GSL "Build with GSL support" ON)
+option(NS3_GTK3 "Build with GTK3 support" ON)
+option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
+option(NS3_MONOLIB
+       "Build a single shared ns-3 library and link it against executables" OFF
+)
+option(NS3_MPI "Build with MPI support" OFF)
+option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
+set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
+option(NS3_PRECOMPILE_HEADERS
+       "Precompile module headers to speed up compilation" ON
+)
+option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
+option(NS3_REALTIME "Build with realtime support" ON)
+option(NS3_SQLITE "Build with SQLite support" ON)
+option(NS3_STATIC "Build a static ns-3 library and link it against executables"
+       OFF
+)
+option(NS3_VERBOSE "Print additional build system messages" OFF)
+option(NS3_VISUALIZER "Build visualizer module" ON)
+option(NS3_WARNINGS "Enable compiler warnings" ON)
+option(NS3_WARNINGS_AS_ERRORS
+       "Treat warnings as errors. Requires NS3_WARNINGS=ON" ON
+)
+
+# Options that either select which modules will get built or disable modules
+set(NS3_ENABLED_MODULES ""
+    CACHE STRING "List of modules to enable (e.g. core;network;internet)"
+)
+set(NS3_DISABLED_MODULES ""
+    CACHE STRING "List of modules to disable (e.g. lte;wimax;wave)"
+)
+
+# Include macros used below
+include(build-support/macros-and-definitions.cmake)
+
+# Scan module libraries
+subdirlist(libs_to_build ${CMAKE_SOURCE_DIR}/src)
+
+# Scan contribution libraries
+subdirlist(contrib_libs_to_build ${CMAKE_SOURCE_DIR}/contrib)
+
+# Before filtering, we need to load settings from .ns3rc
+parse_ns3rc(ns3rc_enabled_modules ns3rc_examples_enabled ns3rc_tests_enabled)
+
+# After scanning modules, we can filter enabled and disabled ones
+filter_enabled_and_disabled_modules(
+  libs_to_build contrib_libs_to_build NS3_ENABLED_MODULES NS3_DISABLED_MODULES
+  ns3rc_enabled_modules
+)
+
+# ##############################################################################
+# Process options                     #
+# ##############################################################################
+process_options()
+
+# ##############################################################################
+# Add subdirectories                  #
+# ##############################################################################
+# Build NS3 library core
+add_subdirectory(src)
+
+# Build NS library examples
+add_subdirectory(examples)
+
+# Build scratch/simulation scripts
+add_subdirectory(scratch)
+
+# Build test utils
+add_subdirectory(utils)
+
+write_lock()
+write_configtable()
+write_header_to_modules_map()
+
+# Export package targets when installing
+ns3_cmake_package()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/contributing/figures/README ns-3.36/doc/contributing/figures/README
--- ns-3.35/doc/contributing/figures/README	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/doc/contributing/figures/README	2022-04-30 18:23:57.646732600 -0700
@@ -0,0 +1,18 @@
+Please write image files in a vector graphics format, when possible, and
+generate the .png and .pdf versions on the fly (see ../Makefile).  
+
+The currently supported tool is dia.  xfig could be added similarly
+if someone wants to add it.  The main requirement for adding another format
+is that the tool to edit it is freely available and that a cron script can 
+autogenerate the pdf and png from the figure source.  Tgif (.obj) files
+were once used but the file conversions require a valid X display to 
+be running, and are therefore to be avoided since our code server 
+does not run such a server.  Tgif pdf conversions were also cumbersome.
+
+Store the .dia versions in git, but not the .png or .pdfs.  
+If the figure is not available in a vector graphics format, store both
+a .png and a .pdf version in this directory.
+
+If you add a source (.dia) file here, remember to add it to
+the list of figure sources in the Makefile in the directory above
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/contributing/Makefile ns-3.36/doc/contributing/Makefile
--- ns-3.35/doc/contributing/Makefile	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/doc/contributing/Makefile	2022-04-30 18:23:57.646732600 -0700
@@ -0,0 +1,165 @@
+# Makefile for Sphinx documentation
+#
+
+# You can set these variables from the command line.
+SPHINXOPTS    =
+SPHINXBUILD   = sphinx-build
+PAPER         =
+BUILDDIR      = build
+
+# Internal variables.
+PAPEROPT_a4     = -D latex_paper_size=a4
+PAPEROPT_letter = -D latex_paper_size=letter
+ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
+
+# Additional variables for figures, not sphinx default:
+DIA = dia
+EPSTOPDF = epstopdf
+FIGURES = source/figures
+IMAGES_EPS = \
+
+IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
+IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}
+
+IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)
+
+.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest
+
+.NOTPARALLEL:
+
+%.eps : %.dia
+	@echo dia $(notdir $<)
+	@$(DIA) -t eps $< -e $@ >/dev/null
+
+%.png : %.dia
+	@echo dia $(notdir $<)
+	@$(DIA) -t png $< -e $@ >/dev/null
+
+%.png : %.eps
+	@echo convert $(notdir $<)
+	@$(CONVERT) $< $@ >/dev/null
+
+%.pdf : %.eps
+	@echo epstopdf $(notdir $<)
+	@$(EPSTOPDF) $< -o=$@ >/dev/null
+	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
+
+help:
+	@echo "Please use \`make <target>' where <target> is one of"
+	@echo "  html       to make standalone HTML files"
+	@echo "  dirhtml    to make HTML files named index.html in directories"
+	@echo "  singlehtml to make a single large HTML file"
+	@echo "  pickle     to make pickle files"
+	@echo "  json       to make JSON files"
+	@echo "  htmlhelp   to make HTML files and a HTML help project"
+	@echo "  qthelp     to make HTML files and a qthelp project"
+	@echo "  devhelp    to make HTML files and a Devhelp project"
+	@echo "  epub       to make an epub"
+	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
+	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
+	@echo "  text       to make text files"
+	@echo "  man        to make manual pages"
+	@echo "  changes    to make an overview of all changed/added/deprecated items"
+	@echo "  linkcheck  to check all external links for integrity"
+	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
+
+clean:
+	-rm -rf $(BUILDDIR)
+
+frag: pickle
+	@if test ! -d $(BUILDDIR)/frag; then mkdir $(BUILDDIR)/frag; fi
+	pushd $(BUILDDIR)/frag && ../../pickle-to-xml.py ../pickle/index.fpickle  > navigation.xml && popd
+	cp -r $(BUILDDIR)/pickle/_images $(BUILDDIR)/frag
+
+html: $(IMAGES)
+	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
+
+dirhtml: $(IMAGES)
+	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."
+
+singlehtml: $(IMAGES)
+	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
+	@echo
+	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."
+
+pickle: $(IMAGES)
+	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
+	@echo
+	@echo "Build finished; now you can process the pickle files."
+
+json: $(IMAGES)
+	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
+	@echo
+	@echo "Build finished; now you can process the JSON files."
+
+htmlhelp: $(IMAGES)
+	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
+	@echo
+	@echo "Build finished; now you can run HTML Help Workshop with the" \
+	      ".hhp project file in $(BUILDDIR)/htmlhelp."
+
+qthelp: $(IMAGES)
+	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
+	@echo
+	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
+	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
+	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/ns-3.qhcp"
+	@echo "To view the help file:"
+	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/ns-3.qhc"
+
+devhelp: $(IMAGES)
+	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
+	@echo
+	@echo "Build finished."
+	@echo "To view the help file:"
+	@echo "# mkdir -p $$HOME/.local/share/devhelp/ns-3"
+	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/ns-3"
+	@echo "# devhelp"
+
+epub: $(IMAGES)
+	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
+	@echo
+	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."
+
+latex: $(IMAGES)
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
+	@echo
+	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
+	@echo "Run \`make' in that directory to run these through (pdf)latex" \
+	      "(use \`make latexpdf' here to do that automatically)."
+
+latexpdf: $(IMAGES)
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
+	@echo "Running LaTeX files through pdflatex..."
+	make -C $(BUILDDIR)/latex all-pdf
+	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."
+
+text: $(IMAGES)
+	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
+	@echo
+	@echo "Build finished. The text files are in $(BUILDDIR)/text."
+
+man: $(IMAGES)
+	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
+	@echo
+	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."
+
+changes: $(IMAGES)
+	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
+	@echo
+	@echo "The overview file is in $(BUILDDIR)/changes."
+
+linkcheck: $(IMAGEs)
+	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
+	@echo
+	@echo "Link check complete; look for any errors in the above output " \
+	      "or in $(BUILDDIR)/linkcheck/output.txt."
+
+doctest: $(IMAGES)
+	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
+	@echo "Testing of doctests in the sources finished, look at the " \
+	      "results in $(BUILDDIR)/doctest/output.txt."
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/contributing/pickle-to-xml.py ns-3.36/doc/contributing/pickle-to-xml.py
--- ns-3.35/doc/contributing/pickle-to-xml.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/doc/contributing/pickle-to-xml.py	2022-04-30 18:23:57.646732600 -0700
@@ -0,0 +1,42 @@
+#!/usr/bin/python
+
+
+# output xml format:
+# <pages>
+# <page url="xx"><prev url="yyy">zzz</prev><next url="hhh">lll</next><fragment>file.frag</fragment></page>
+# ...
+# </pages>
+
+import pickle
+import os
+import codecs
+
+def dump_pickles(out, dirname, filename, path):
+    f = open(os.path.join(dirname, filename), 'r')
+    data = pickle.load(f)
+    fragment_file = codecs.open(data['current_page_name'] + '.frag', mode='w', encoding='utf-8')
+    fragment_file.write(data['body'])
+    fragment_file.close()
+    out.write('  <page url="%s">\n' % path)
+    out.write('    <fragment>%s.frag</fragment>\n' % data['current_page_name'])
+    if data['prev'] is not None:
+        out.write('    <prev url="%s">%s</prev>\n' % 
+                  (os.path.normpath(os.path.join(path, data['prev']['link'])), 
+                   data['prev']['title']))
+    if data['next'] is not None:
+        out.write('    <next url="%s">%s</next>\n' % 
+                  (os.path.normpath(os.path.join(path, data['next']['link'])), 
+                   data['next']['title']))
+    out.write('  </page>\n')
+    f.close()
+    if data['next'] is not None:
+        next_path = os.path.normpath(os.path.join(path, data['next']['link']))
+        next_filename = os.path.basename(next_path) + '.fpickle'
+        dump_pickles(out, dirname, next_filename, next_path)
+    return
+
+import sys
+
+sys.stdout.write('<pages>\n')
+dump_pickles(sys.stdout, os.path.dirname(sys.argv[1]), os.path.basename(sys.argv[1]), '/')
+sys.stdout.write('</pages>')
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/contributing/source/figures/README ns-3.36/doc/contributing/source/figures/README
--- ns-3.35/doc/contributing/source/figures/README	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/doc/contributing/source/figures/README	2022-04-30 18:23:57.646732600 -0700
@@ -0,0 +1,18 @@
+Please write image files in a vector graphics format, when possible, and
+generate the .png and .pdf versions on the fly (see ../Makefile).  
+
+The currently supported tool is dia.  xfig could be added similarly
+if someone wants to add it.  The main requirement for adding another format
+is that the tool to edit it is freely available and that a cron script can 
+autogenerate the pdf and png from the figure source.  Tgif (.obj) files
+were once used but the file conversions require a valid X display to 
+be running, and are therefore to be avoided since our code server 
+does not run such a server.  Tgif pdf conversions were also cumbersome.
+
+Store the .dia versions in git, but not the .png or .pdfs.  
+If the figure is not available in a vector graphics format, store both
+a .png and a .pdf version in this directory.
+
+If you add a source (.dia) file here, remember to add it to
+the list of figure sources in the Makefile in the directory above
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/doxygen.warnings.report.sh ns-3.36/doc/doxygen.warnings.report.sh
--- ns-3.35/doc/doxygen.warnings.report.sh	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/doxygen.warnings.report.sh	2022-04-30 18:23:57.646732600 -0700
@@ -15,7 +15,6 @@
 WARNINGSLOGFILE=doxygen.warnings.log
 # Default choice:  generate it
 LOG="$DIR/$WARNINGSLOGFILE"
-
 # Verbose log
 VERBLOG="$DIR/doxygen.verbose.log"
 
@@ -66,7 +65,7 @@
     report all undocumented elements, and to reduce the run time.
     The output of this special run is kept in doc/$WARNINGSLOGFILE.
     To further reduce the run time, the -i option also skips
-    print-introspected-doxygen, so waf doesn\'t have to compile
+    print-introspected-doxygen, so ns3 doesn\'t have to compile
     any modified files at all.
 
     The -f, -l, and -s options skip the doxygen run altogether.
@@ -309,7 +308,10 @@
 else
 
     # Modify doxygen.conf to generate all the warnings
-    # (We also suppress dot graphs, so shorten the run time.)
+    # We keep dot active to generate graphs in the documentaion
+    # (see for example PacketTagList) and warn about ill-formed
+    # graphs, but we disable all the doxygen-generated diagrams
+    # to shorten the run time.
 
     conf=doc/doxygen.conf
     cp $conf ${conf}.bak
@@ -317,29 +319,37 @@
 
     # doxygen.warnings.report.sh:
     EXTRACT_ALL = no
-    HAVE_DOT = no
-    CLASS_DIAGRAMS = no
     WARNINGS = no
-    SOURCE_BROWSER = no
-    HTML_OUTPUT html-warn
     WARN_LOGFILE = doc/$WARNINGSLOGFILE
+    SOURCE_BROWSER = no
+    HTML_OUTPUT = html-warn
+    CLASS_DIAGRAMS = no
+    CLASS_GRAPH = no
+    COLLABORATION_GRAPH = no
+    GROUP_GRAPHS = no
+    INCLUDE_GRAPH = no
+    INCLUDED_BY_GRAPH = no
+    CALL_GRAPH = no
+    CALLER_GRAPH = no
+    GRAPHICAL_HIERARCHY = no
+    DIRECTORY_GRAPH = no
 EOF
 
 
     intro_h="introspected-doxygen.h"
     if [ $skip_intro -eq 1 ]; then
-        verbose "" "Skipping ./waf build"
+        verbose "" "Skipping ./ns3 build"
         verbose -n "Trying print-introspected-doxygen with doxygen build"
-        (cd "$ROOT" && ./waf --run-no-build print-introspected-doxygen >doc/$intro_h 2>&6 )
-        status_report $? "./waf --run print-introspected-doxygen" noexit
+        (cd "$ROOT" && ./ns3 run print-introspected-doxygen --no-build >doc/$intro_h 2>&6 )
+        status_report $? "./ns3 run print-introspected-doxygen" noexit
     else
         # Run introspection, which may require a build
         verbose -n "Building"
-        (cd "$ROOT" && ./waf build >&6 2>&6 )
-        status_report $? "./waf build"
+        (cd "$ROOT" && ./ns3 build >&6 2>&6 )
+        status_report $? "./ns3 build"
         verbose -n "Running print-introspected-doxygen with doxygen build"
-        (cd "$ROOT" && ./waf --run-no-build print-introspected-doxygen >doc/$intro_h 2>&6 )
-        status_report $? "./waf --run print-introspected-doxygen"
+        (cd "$ROOT" && ./ns3 run print-introspected-doxygen --no-build >doc/$intro_h 2>&6 )
+        status_report $? "./ns3 run print-introspected-doxygen"
     fi
 
     # Waf insists on writing cruft to stdout
@@ -347,8 +357,8 @@
     rm doc/$intro_h.bak
 
     verbose -n "Rebuilding doxygen docs with full errors"
-    (cd "$ROOT" && ./waf --doxygen-no-build >&6 2>&6 )
-    status_report $? "./waf --doxygen-no-build"
+    (cd "$ROOT" && ./ns3 docs doxygen-no-build >&6 2>&6 )
+    status_report $? "./ns3 docs doxygen-no-build"
 
     # Swap back to original config
     rm -f $conf
@@ -383,23 +393,34 @@
 
 verbose -n "Filtering the doxygen log"
 
-# List of module directories (e.g, "src/core/model")
-undocmods=$(                \
-    filter_log            | \
-    cut -d ':' -f 1       | \
-    sed "s|$ROOT/||g"     | \
-    cut -d '/' -f 1-3     | \
-    sort                  | \
-    uniq -c               | \
-    sort -nr                \
-    )
+filter_log_results=$(filter_log)
 
-# Number of directories
-modcount=$(                         \
-    echo "$undocmods"             | \
-    wc -l                         | \
-    sed 's/^[ \t]*//;s/[ \t]*$//'   \
-    )
+# List of module directories (e.g, "src/core/model")
+if [ ! -z "$filter_log_results" ]
+then
+    undocmods=$(                \
+        filter_log            | \
+        cut -d ':' -f 1       | \
+        sed "s|$ROOT/||g"     | \
+        cut -d '/' -f 1-3     | \
+        sort                  | \
+        uniq -c               | \
+        sort -nr                \
+        )
+    modcount=$(                         \
+        echo "$undocmods"             | \
+        wc -l                         | \
+        sed 's/^[ \t]*//;s/[ \t]*$//'   \
+        )
+    modwarncount=$(                               \
+        echo "$undocmods"                       | \
+        awk '{total += $1}; END {print total}'    \
+        )
+else
+    undocmods=""
+    modcount=0
+    modwarncount=0
+fi
 
 # For a function with multiple undocumented parameters,
 # Doxygen prints the additional parameters on separate lines,
@@ -413,32 +434,38 @@
     )
 
 # Total number of warnings
-warncount=$(                                  \
-    echo "$undocmods"                       | \
-    awk '{total += $1}; END {print total}'    \
-    )
-warncount=$((warncount + addlparam))
+warncount=$((modwarncount + addlparam))
 
 # List of files appearing in the log
-undocfiles=$(               \
-    filter_log            | \
-    cut -d ':' -f 1       | \
-    sed "s|$ROOT||g"      | \
-    cut -d '/' -f 2-      | \
-    sort                  | \
-    uniq -c               | \
-    sort -k 2               \
-    )
+if [ ! -z "$filter_log_results" ]
+then
+    undocfiles=$(               \
+        filter_log            | \
+        cut -d ':' -f 1       | \
+        sed "s|$ROOT||g"      | \
+        cut -d '/' -f 2-      | \
+        sort                  | \
+        uniq -c               | \
+        sort -k 2               \
+        )
+else
+    undocfiles=""
+fi
 
 # Sorted by number, decreasing
 undocsort=$(echo "$undocfiles" | sort -k1nr,2 )
 
 # Total number of files
-filecount=$(                        \
-    echo "$undocfiles"            | \
-    wc -l                         | \
-    sed 's/^[ \t]*//;s/[ \t]*$//'   \
-    )
+if [ ! -z "$undocfiles" ]
+then
+    filecount=$(                        \
+        echo "$undocfiles"            | \
+        wc -l                         | \
+        sed 's/^[ \t]*//;s/[ \t]*$//'   \
+        )
+else
+    filecount=0
+fi
 
 # Filtered in warnings
 filterin=
@@ -519,9 +546,6 @@
     echo "Filtered Warnings"
     echo "========================================"
     echo "$filterin"
-    exit_status=1
-else
-    exit_status=0
 fi
 
 status_report 0 $me
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/doc/main.h ns-3.36/doc/main.h
--- ns-3.35/doc/main.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/doc/main.h	2022-04-30 18:23:57.646732600 -0700
@@ -17,9 +17,9 @@
  *
  * \section install-sec Building the Documentation
  * 
- * ns-3 requires Doxygen version 1.8.3.1 or greater.
+ * Building ns-3 Doxygen requires Doxygen version 1.8 at a minimum, but version 1.9 is recommended to minimize warnings.
  * 
- * Type "./waf --doxygen" or "./waf --doxygen-no-build" to build the 
+ * Type "./ns3 docs doxygen" or "./ns3 docs doxygen-no-build" to build the
  *  documentation.  The doc/ directory contains
  * configuration for Doxygen (doxygen.conf) and main.h.  The Doxygen 
  * build process puts html files into the doc/html/ directory, and latex 
@@ -91,7 +91,7 @@
  *
  * Enable asserts at compile time.
  *
- * This is normally set by `./waf configure --build-profile=debug`.
+ * This is normally set by `./ns3 configure --build-profile=debug`.
  */
 #define NS3_ASSERT_ENABLE
 
@@ -102,7 +102,7 @@
  *
  * Enable logging at compile time.
  *
- * This is normally set by `./waf configure --build-profile=debug`.
+ * This is normally set by `./ns3 configure --build-profile=debug`.
  */
 #define NS3_LOG_ENABLE
 
